﻿using Microsoft.Phone.Controls;
using System;
using System.Net;
using System.Windows;
using System.Runtime.Serialization.Json;
using ESRI.ArcGIS.Client.WebMap;
using System.Runtime.Serialization;

namespace ArcGISWindowsPhoneSDK
{
    public partial class LoadSecureWebMap : PhoneApplicationPage
    {
        public LoadSecureWebMap()
        {
            InitializeComponent();
        }

        private void LoadWebMapButton_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            WebClient webClient = new WebClient();

            string arcgisComTokenUrl = "https://www.arcgis.com/sharing/generateToken";
            arcgisComTokenUrl += string.Format("?username={0}&password={1}&expiration={2}&TickCount={3}&client=requestip&f=json",
                UsernameTextBox.Text, PasswordTextBox.Password, 30, Environment.TickCount);

            webClient.OpenReadCompleted += (s, a) =>
            {
                Document webMap = new Document();

                DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(TokenDataContract));
                TokenDataContract tokenDataContract = serializer.ReadObject(a.Result) as TokenDataContract;
                string token = tokenDataContract.Token;
                webMap.Token = token;

                webMap.GetMapCompleted += webMap_GetMapCompleted;
                webMap.GetMapAsync(WebMapTextBox.Text);
            };

            webClient.OpenReadAsync(new Uri(arcgisComTokenUrl));
        }

        void webMap_GetMapCompleted(object sender, GetMapCompletedEventArgs e)
        {
            if (e.Error != null)
                MessageBox.Show(string.Format("Unable to load webmap. {0}", e.Error.Message));
            else
                ContentGrid.Children.Insert(0, e.Map);
        }

        [DataContract]
        public class TokenDataContract
        {
            [DataMember(Name = "token")]
            public string Token { get; set; }
        }
    }
}